//+------------------------------------------------------------------+
//|                                                 3BarStopLoss.mq4 |
//|                           Copyright  2009, Forex-Tools-Cafe.com |
//|                                  http://www.forex-tools-cafe.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Forex-Tools-Cafe.com"
#property link      "http://www.forex-tools-cafe.com"

#property indicator_chart_window
#property  indicator_buffers 4

extern string TimeFrame = "enter time frame here";
extern bool  UseSpreadOffset=true;
extern int   ManualOffset=4; 
extern int   MaxBars=2000; 
extern int   TrendEMAPeriod=2;
extern int   lookback=3;


extern string S1="Line Style: 0=line,1=dash,2=dots"; 
extern int     StopLineStyle=2; 
extern int     EntryLineStyle=0; 
extern int     EntryLineWidth=3; 
extern color   SellColor=Red;
extern color   BuyColor=Blue; 

double  SellStop[];
double  BuyEntry[];
double  SellEntry[];
double  BuyStop[]; 

int     Trend; 
int timeFrame;
string indicatorFileName;
bool   returnBars;


int init()
{

   // IndicatorBuffers(4);
    
   SetIndexBuffer(0,SellStop ); 
   SetIndexBuffer(1,BuyEntry ); 
   SetIndexBuffer(2,SellEntry); 
   SetIndexBuffer(3,BuyStop  ); 
   
   
  
   timeFrame = stringToTimeFrame(TimeFrame);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";
      
   return(0);
}

int deinit()
{

   return(0);
}

int start()
{
   int    counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars ;

   SetIndexStyle(0,DRAW_LINE, StopLineStyle, 1 , SellColor  );
   SetIndexStyle(1,DRAW_LINE, EntryLineStyle, EntryLineWidth , BuyColor  );
   
   SetIndexStyle(2,DRAW_LINE, EntryLineStyle, EntryLineWidth , SellColor  );
   SetIndexStyle(3,DRAW_LINE, StopLineStyle, 1 , BuyColor  );
   
   if ( limit > MaxBars ) limit = MaxBars; 
         if (returnBars) { SellStop[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  SellStop[i]  = iCustom(NULL,timeFrame,indicatorFileName,"",UseSpreadOffset,ManualOffset,MaxBars,TrendEMAPeriod,lookback,0,y);
                  BuyEntry[i]  = iCustom(NULL,timeFrame,indicatorFileName,"",UseSpreadOffset,ManualOffset,MaxBars,TrendEMAPeriod,lookback,1,y);
                  SellEntry[i] = iCustom(NULL,timeFrame,indicatorFileName,"",UseSpreadOffset,ManualOffset,MaxBars,TrendEMAPeriod,lookback,2,y);
                  BuyStop[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",UseSpreadOffset,ManualOffset,MaxBars,TrendEMAPeriod,lookback,3,y);
            }
            return(0);
         }
   
   
   int offset; 
   if ( UseSpreadOffset ) offset = MarketInfo(Symbol(), MODE_SPREAD ); 
   else
      offset = ManualOffset; 
      
   for(i=limit; i>=0; i--)
   {   
   
      double diff =  iMA(Symbol(), 0, TrendEMAPeriod, 0, MODE_SMMA, PRICE_CLOSE, i)  
                   - iMA(Symbol(), 0, TrendEMAPeriod+1, 0, MODE_SMMA, PRICE_CLOSE, i);
                   
   //   double diff2 =  iMA(Symbol(), 0, TrendEMAPeriod, 0, MODE_SMMA, PRICE_CLOSE, i+1)  
   //                - iMA(Symbol(), 0, TrendEMAPeriod+1, 0, MODE_SMMA, PRICE_CLOSE, i+1);
      
      
      if ( diff >= 0.0   ) // just crossed upward
      {
         Trend = 1;
      }
      else if ( diff < 0.0   )
      {
         Trend = -1;
      }
      
      if (false && i==14)
      {
         Comment("SellStop[i]: " + SellStop[i]
            + "\ndiff: " + diff
          //  + "\ndiff2: " + diff2
            + "\nBuyEntry[i]: " + BuyEntry[i]
            + "\nSellEntry[i]: " + SellEntry[i]
            + "\nBuyStop[i]: " + BuyStop[i]
            
          ); 
      
      }
   
      if ( Trend == 1 ) 
      {
         int lo = ArrayMinimum(Low,lookback,i);
         
         SellStop[i]=EMPTY_VALUE;
         BuyEntry[i]=High[i+1];
         SellEntry[i]=EMPTY_VALUE;
         double sl = Low[lo]-(offset)*Point; 
         if ( BuyStop[i+1]!=EMPTY_VALUE && sl < BuyStop[i+1] ) 
            BuyStop[i]= BuyStop[i+1];
         else 
            BuyStop[i]= sl; 
      
      }
      else if ( Trend == -1 )
      {
         int hi = ArrayMaximum(High,lookback,i);
         
         double slsell = High[hi] + (offset)*Point;
         if ( SellStop[i+1]!=EMPTY_VALUE && slsell > SellStop[i+1] )
            SellStop[i]= SellStop[i+1]; 
         else
            SellStop[i] = slsell; 
            
         BuyEntry[i]=EMPTY_VALUE ;
         SellEntry[i]=Low[i+1];
         BuyStop[i]=EMPTY_VALUE; 
      
      }
   }

   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}